<SCRIPT LANGUAGE="JScript" RUNAT="Server">
// Copyright 1999 Sumatra Solutions srl. All rights reserved
// This program is free software; you can redistribute it and/or modify it
// under the GNU General Artistic License, with the following stipulations;
// Changes or modifications must retain these Copyright statements. Changes or
// modifications must be submitted to both AUTHORS.
// $Id: ftemplate.asp,v 1.11 1999/11/17 18:06:46 ludo Exp $
//
// Modified by Wu Yongwei, 07 Jun 2000 - 08 Jun 2000
//
// Some minor bugs fixed, and calls from VBScript enabled

function fasttemplate(path, strict) {
  // Properties
  this.filelist  = new Array();     // Holds the array of filehandles FILELIST[HANDLE] == "fileName"
  this.parsevars = new Array();     // Holds the array of Variable handles. PARSEVARS[HANDLE] == "value"
  this.last      = new String();    // Holds the HANDLE to the last template parsed by parse()
  if (path != "") {                 // Check if anything was passed as a path
    this.root = path;
  } else {
    Response.Write("Path to templates directory not set");
  }
  this.strict    = (typeof(strict) == "undefined" ? true : strict);
  this.error_log = new Array();
  // Methods
  this.assign = ft_assign;
  this.define = ft_define;
  this.parse = ft_parse;
  this.get_template = ft_get_template;
  this.parse_template = ft_parse_template;
  this.fastprint = ft_fastprint;
  this.error = ft_error;
  this.strict_on = ft_strict_on;
  this.strict_off = ft_strict_off;
}

function ft_define(filelist) {
  for (filetag in filelist) {
    this.filelist[filetag] = filelist[filetag];
  }
}

function ft_assign(tpl_array, trailer) {
  if(typeof(tpl_array) == "string") {
    if (tpl_array != "") {
      this.parsevars[tpl_array] = trailer;
    }
  } else {
    for (key in tpl_array) {
      this.parsevars[key] = tpl_array[key];
    }
  }
}

function ft_parse(returnvar, filetags) {
  var append = false;
  this.last = returnvar;
  if (filetags.constructor == Array) {
    this[returnvar] = new String();
    for (key in filetags) {
      var val = filetags[key];
      if (typeof(this[val]) == "undefined") {
        filename = this.filelist[val];
        this[val] = this.get_template(filename);
      }
      this[returnvar] += this.parse_template(this[val], this.parsevars);
      // For recursive calls.
      var tmparray = new Array();
      tmparray[returnvar] = this[returnvar];
      this.assign(tmparray);
    }
  } else {
    var val = filetags;
    var myre = /^\./;
    if(myre.test(val)) { // Append
      append = true;
      val = val.substr(1);
    }
    if (typeof(this[val]) == "undefined") {
      var filename = this.filelist[val];
      this[val] = this.get_template(filename);
    }
    if (append) {
      this[returnvar] += this.parse_template(this[val], this.parsevars);
    } else {
      this[returnvar] = this.parse_template(this[val], this.parsevars);
    }
    var tmparray = new Array();
    tmparray[returnvar] = this[returnvar];
    this.assign(tmparray);
  }
}

function ft_get_template(template) {
  var filename = this.root + "\\" + template;
  var myfsobj  = new ActiveXObject("Scripting.FileSystemObject");
  if(!myfsobj.FileExists(filename)) {
    this.error("[" + filename + "] does not exist");
  }
  var myhandle = myfsobj.OpenTextFile(filename);
  var contents = myhandle.ReadAll();
  return contents;
}

function ft_parse_template(template, tpl_array) {
  for (mykey in tpl_array) {
    var myvalue = tpl_array[mykey];
    var myre    = new RegExp("{" + mykey + "}", "g");
    template    = template.replace(myre, myvalue);
  }
  var myre = /{[A-Z0-9_]+}/;
  // Code for strict
  if(!this.strict) {
    template = template.replace(myre, "");
  } else {
    var unknown = template.match(myre);
    if (typeof(unknown) != "undefined") {
      for (i in unknown) {
        this.error_log[this.error_log.length] = "[FastTemplate] Warning: no value found for variable: " + unknown[i];
      }
    }
  }
  return(template);
}

function ft_fastprint(template) {
  if (typeof(template) == "undefined" || template == "") {
    template = this.last;
  }
  if (typeof(this[template]) == "undefined") {
    Response.Write("Nothing parsed, nothing printed");
  } else {
    Response.Write(this[template]);
  }
}

function ft_error(myerrmsg) {
  Response.Write("<font color=\"red\" face=\"Arial,Helvetica,sans-serif\"><b>" + myerrmsg + "</b></font>");
}

function ft_strict_on() {
  this.strict = true;
}

function ft_strict_off() {
  this.strict = false;
}

// The following functions enable calls from VBScript

function CreateTemplate(path, strict) {
  return new fasttemplate(path, strict);
}

function DefineTemplate(template) {
  var filelist = new Array();
  for (i = 1; i < arguments.length - 1; i += 2)
    filelist[arguments[i]] = arguments[i + 1];
  template.define(filelist);
}

function GetValueFromTemplate(template, returnvar) {
  return template[returnvar];
}
</SCRIPT>