<%
' Copyright (C) 2000, 2001 Wu Yongwei. All rights reserved.
'
' Version:            1.00.0001
' Original Author:    Wu Yongwei
' Creation Date:      15 Jun 2000
' Last Update:        06 Aug 2001
' Modified By:
' Modification Date:
'
' Adapted from <URL:http://www.4guysfromrolla.com/webtech/010100-1.shtml>
'

Dim RC4SBox(255)
Dim RC4Key(255)

Sub RC4Initialize(psw)
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
':::  This routine called by EnDeCrypt function. Initializes the :::
':::  sbox and the key array)                                    :::
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  Dim intLength
  Dim tempSwap
  Dim a
  Dim b

  intLength = LenB(psw)
  For a = 0 To 255
    RC4Key(a) = AscB(MidB(psw, (a Mod intLength) + 1, 1))
    RC4SBox(a) = a
  next

  b = 0
  For a = 0 To 255
    b = (b + RC4SBox(a) + RC4Key(a)) Mod 256
    tempSwap = RC4SBox(a)
    RC4SBox(a) = RC4SBox(b)
    RC4SBox(b) = tempSwap
  Next

End Sub

Function EnDeCrypt(plaintxt, psw)
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
':::  This routine does all the work. Call it both to ENcrypt    :::
':::  and to DEcrypt your data.                                  :::
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  Dim temp
  Dim a
  Dim i
  Dim j
  Dim k
  Dim cipherby
  Dim cipher

  i = 0
  j = 0

  RC4Initialize psw

  For a = 1 To LenB(plaintxt)
    i = (i + 1) Mod 256
    j = (j + RC4SBox(i)) Mod 256
    temp = RC4SBox(i)
    RC4SBox(i) = RC4SBox(j)
    RC4SBox(j) = temp

    k = RC4SBox((RC4SBox(i) + RC4SBox(j)) Mod 256)

    cipherby = AscB(MidB(plaintxt, a, 1)) Xor k
    cipher = cipher & ChrB(cipherby)
  Next

  EnDeCrypt = cipher

End Function
%>