<%
' Copyright (C) 2000, 2001 Wu Yongwei. All rights reserved.
'
' Version:            1.01.0003
' Original Author:    Wu Yongwei
' Creation Date:      06 Sep 2000
' Last Update:        06 Aug 2001
' Modified By:
' Modification Date:
'
' Adapted from <URL:http://tech.dimac.net/> as an example of using w3 Sockets by Max Baehring.
' Revised thoroughly to fix bugs and make it compact, consistent, and conformable to HTTP 1.0 (RFC 1945)
'

Const HttpResponseHeader = 0
Const HttpResponseBody = 1

Dim TearHttpHeader()
Dim TearHttpHeaderCnt, TearHttpTimeout
ReDim TearHttpHeader(1, 0)
TearHttpHeaderCnt = -1
TearHttpTimeout = 10000

Sub TearHttpClearHeader
  TearHttpHeaderCnt = -1
  ReDim TearHttpHeader(1, 0)
End Sub

Sub TearHttpAddHeader(ByVal HttpHeaderName, ByVal HttpHeaderValue)
  Dim TearHttpHeaderChanged, I
  If LCase(Trim(HttpHeaderName)) <> "user-agent" And LCase(Trim(HttpHeaderName)) <> "content-length" And LCase(Trim(HttpHeaderName)) <> "content-type" Then
    TearHttpHeaderChanged = False
    For I = 0 To TearHttpHeaderCnt
      If TearHttpHeader(0, I) = HttpHeaderName Then
        TearHttpHeader(1, I) = HttpHeaderValue
        TearHttpHeaderChanged = True
        Exit For
      End If
    Next
    If Not TearHttpHeaderChanged Then
      TearHttpHeaderCnt = TearHttpHeaderCnt + 1
      If TearHttpHeaderCnt >= 0 Then
        ReDim Preserve TearHttpHeader(1, TearHttpHeaderCnt)
      End If
      TearHttpHeader(0, TearHttpHeaderCnt) = HttpHeaderName
      TearHttpHeader(1, TearHttpHeaderCnt) = HttpHeaderValue
    End If
  End If
End Sub

Sub TearHttpRemoveHeader(ByVal HttpHeaderName)
  Dim I, J
  For I = 0 To TearHttpHeaderCnt
    If TearHttpHeader(0, I) = HttpHeaderName Then
      For J = I To TearHttpHeaderCnt - 1
        TearHttpHeader(0, J) = TearHttpHeader(0, J + 1)
        TearHttpHeader(1, J) = TearHttpHeader(1, J + 1)
      Next
      TearHttpHeaderCnt = TearHttpHeaderCnt - 1
      If TearHttpHeaderCnt >= 0 Then
        ReDim Preserve TearHttpHeader(1, TearHttpHeaderCnt)
      End If
      Exit For
    End If
  Next
End Sub

Function TearHttp(ByVal HttpURL, ByVal HttpPostData)
  Dim Socket, HttpServer, HttpPort, HttpDocument, HttpMethod, HttpSend, I
  If LCase(Left(HttpURL, 7)) = "http://" Then
    HttpURL = Mid(HttpURL, 8)
  End If
  If InStr(HttpURL, "/") = 0 Then
    HttpServer = HttpURL
    HttpDocument = "/"
  Else
    HttpServer = Left(HttpURL, InStr(HttpURL, "/") - 1)
    HttpDocument = Mid(HttpURL, InStr(HttpURL, "/"))
  End If
  If InStr(HttpServer, ":") = 0 Then
    HttpPort = 80
  Else
    HttpPort = Mid(HttpServer, InStr(HttpServer, ":") + 1)
    HttpServer = Left(HttpServer, InStr(HttpServer, ":") - 1)
  End If
  If HttpPostData <> "" Then
    HttpMethod = "POST"
  Else
    HttpMethod = "GET"
  End If
  ' Proxy support: Use "HttpProxyName//DestinationURL" as HttpURL
  If Left(HttpDocument, 2) = "//" Then HttpDocument = Mid(HttpDocument, 3)
  HttpSend = HttpMethod & " " & HttpDocument
  HttpSend = HttpSend & " HTTP/1.0" & vbCRLF
  HttpSend = HttpSend & "User-Agent" & ": " & "AspSample TearHTTP 1.0" & vbCRLF
  For I = 0 To TearHttpHeaderCnt
    HttpSend = HttpSend & TearHttpHeader(0, I) & ": " & TearHttpHeader(1, I) & vbCRLF
  Next
  If HttpPostData <> "" Then
    ' Note: DBCS data should be URL-encoded before POST; otherwise there will be lost characters
    HttpSend = HttpSend & "Content-Type" & ": " & "application/x-www-form-urlencoded" & vbCRLF
    HttpSend = HttpSend & "Content-Length" & ": " & Len(HttpPostData) & vbCRLF
    HttpSend = HttpSend & vbCRLF & HttpPostData
  Else
    HttpSend = HttpSend & vbCRLF
  End If
  Set Socket = CreateObject("Socket.TCP")
  Socket.Host = HttpServer & ":" & HttpPort
  Socket.TimeOut = TearHttpTimeout
  Socket.Open
  Socket.SendText HttpSend
  Socket.WaitForDisconnect
  TearHttp = Socket.Buffer
  Socket.Close
  Set Socket = Nothing
End Function

Function HttpResponse(ByVal allHttpResponse, ByVal whichHttpResponse)
  Dim Delimiter
  Delimiter = vbCRLF & vbCRLF
  If InStr(allHttpResponse, Delimiter) <> 0 Then
    Select Case whichHttpResponse
      Case HttpResponseHeader
        HttpResponse = Left(allHttpResponse, InStr(allHttpResponse, Delimiter) - 1)
      Case HttpResponseBody
        HttpResponse = Mid(allHttpResponse, InStr(allHttpResponse, Delimiter) + Len(Delimiter))
    End Select
  End If
End Function
%>